import os
import pathlib
import sys

ROOT_PATH = str(pathlib.Path(__file__).absolute().parents[2])

BENCH_TO_CATE = dict()

def get_category_benchmark_names():
    # 返回一个 Tab 的 index（或 label），Gradio 会自动切换
    benchmark_dir = os.path.join(
        os.path.dirname(os.path.dirname(os.path.dirname(os.path.abspath(__file__)))),
        "benchmarks"
    )
    categories = []
    benchmarks = []
    cb_dict = dict()
    for perspective in os.listdir(benchmark_dir):
        if perspective[0].upper()!=perspective[0] or "." in perspective:continue
        if "cache" in perspective:continue
        categories += [perspective]
        benchs = os.listdir(os.path.join(benchmark_dir,perspective))
        benchmarks += benchs
        cb_dict[perspective] = sorted(benchs)
        for bench in benchs:
            BENCH_TO_CATE[bench] = perspective
    return sorted(categories), sorted(benchmarks), cb_dict



CATEGORY_NAMES, BENCHMARK_NAMES, CATEGORY_BENCHMARKS_DICT = get_category_benchmark_names()
CATEGORY_BENCHMARKS_DICT["/"] = BENCHMARK_NAMES + ["/"] 
TASK_TO_BENCH = dict()
CFG_DEFAULT = "/path/of/the/config"
CFG_PATH = dict()
def get_benchmark_task_dict():
    # 返回一个 Tab 的 index（或 label），Gradio 会自动切换
    benchmark_dir = os.path.join(
        ROOT_PATH, "benchmarks"
    )
    benchmark_task_dict = dict()
    for perspective in os.listdir(benchmark_dir):
        if perspective[0].upper()!=perspective[0] or "." in perspective:continue
        
        for benchmark in os.listdir(os.path.join(benchmark_dir,perspective)):
            

            if not os.path.isdir(os.path.join(benchmark_dir,
                                                     perspective,
                                                     benchmark, "configs")):
                continue
            if benchmark not in benchmark_task_dict:
                benchmark_task_dict[benchmark] = []
            config_path = os.path.join(benchmark_dir,
                                                     perspective,
                                                     benchmark, "configs")
            for yaml_file in os.listdir(config_path):
                benchmark_task_dict[benchmark].append(yaml_file[:-5])
                CFG_PATH[yaml_file[:-5]] = config_path
                TASK_TO_BENCH[yaml_file[:-5]] = benchmark
            if benchmark_task_dict[benchmark] == []:
                del benchmark_task_dict[benchmark]
    
    benchmark_task_dict["/"] = ["/"]
    return benchmark_task_dict

BENCHMARK_TASKS_DICT = get_benchmark_task_dict()
CFG_PATH["/"] = None



BENCHMARK_REMINDER = "Please Choose A Benchmark Above"

DEFAULT_CFG_PATH = "./WebUI/temp"
RAG_CONFIG_PATH = os.path.join(ROOT_PATH, "models/rag/rag_config.yaml")
TASK_TO_BENCH["/"] = "/"



BASE_CMD = [
    "python",os.path.join(ROOT_PATH , "scripts/run.py"),  # 构建完整路径
    "--eval",
]

with open(os.path.join(ROOT_PATH, "WebUI/static/style.css"), "r") as f:
    CSS = f.read()


VLLM_LOG_PATH = f"{ROOT_PATH}/WebUI/tmp/vllm.log"

TMP_PATH = f"{ROOT_PATH}/WebUI/tmp"

VLLM_LOG_END_CHAR ="<|END VLLM LOG|>"


CURRENT_STATUS = None

CURRENT_CONSOLE_INDEX_PATH = f"{TMP_PATH}/console_index"


HISTORY_MAP = None