from WebUI.benchmarks.constant import TMP_PATH
import json, os

def save_all(
        save_path,
        model_path,
        config_path,
        torch_dtype,
        adapter_path,
        enable_thinking,
        use_hf_endpo,
        save_tag,
        vllm_max_model_len,
        gpu_memory_utilization,
        max_length,
        server,
        acceleration,
        rag_method,
        chunk_size,
        num_chunks,
        chunk_overlap,
        num_processes,
        openai_api,
        embedding_model,
        base_url,
        category,
        benchmark,
        task,
        num_sample,
        hardware_config,
        vllm_log,
        real_time_log
):
    os.makedirs(os.path.dirname(save_path), exist_ok = True)
    with open(save_path,"w") as f:
        json.dump(dict(
                    model_path = model_path,
                    config_path = config_path,
                    torch_dtype = torch_dtype,
                    adapter_path = adapter_path,
                    enable_thinking = enable_thinking,
                    hugging_face = use_hf_endpo,
                    save_tag = save_tag,
                    vllm_max_model_len = vllm_max_model_len,
                    gpu_memory_utilization = gpu_memory_utilization,
                    max_length = max_length,
                    server = server,
                    acceleration = acceleration,
                    rag_method = rag_method,
                    chunk_size  = chunk_size,
                    num_chunks = num_chunks,
                    chunk_overlap = chunk_overlap,
                    num_processes = num_processes,
                    openai_api = openai_api,
                    embedding_model = embedding_model,
                    base_url = base_url,
                    category = category,
                    benchmark = benchmark,
                    task = task,
                    num_sample = num_sample,
                    hardware_config = hardware_config,
                    vllm_log = vllm_log,
                    real_time_log = real_time_log
        ), f)


def load_all():
    ...