from __future__ import annotations
from typing import Iterable
import gradio as gr
from gradio.themes.base import Base
from gradio.themes.utils import colors, fonts, sizes
import time

gray = colors.Color(
    name="gray",
    c50="#f9fafb",
    c100="#f3f4f6",
    c200="#e5e7eb",
    c300="#d1d5db",
    c400="#9ca3af",
    c500="#6b7280",
    c600="#4b5563",
    c700="#374151",
    c800="#1f2937",
    c900="#111827",
    c950="#0b0f19",
)

loom_green = colors.Color(
    name="loom_green_dark",
    c50="#636363", #/
    c100="#f3f4f6",#/title and markdown font color 
    c200="#d2d7e2",#/ textbox font color
    c300="#636363", #/ checkbox color
    c400="#9ca3af",# c400="#34d399", #/ slider font color
    c500="#6b7280", #/ sub title font label color
    c600="#4b5563",# second button color
    c700="#565858", # text background
    c800="#1f2937", # row background
    c900="#064e3b",#/

    c950="#0b0f19",#    c950="#054436", #website background
)

class Seafoam(Base):
    def __init__(
        self,
        *,
        # primary_hue: colors.Color | str = colors.emerald,
        # secondary_hue: colors.Color | str = colors.blue,
        # neutral_hue: colors.Color | str = colors.gray,
        primary_hue: colors.Color | str = colors.emerald,
        secondary_hue: colors.Color | str = colors.blue,
        neutral_hue: colors.Color | str = loom_green,
        spacing_size: sizes.Size | str = sizes.spacing_md,
        radius_size: sizes.Size | str = sizes.radius_md,
        text_size: sizes.Size | str = sizes.text_lg,
        font: fonts.Font
        | str
        | Iterable[fonts.Font | str] = (
            fonts.GoogleFont("Quicksand"),
            "ui-sans-serif",
            "sans-serif",
        ),
        font_mono: fonts.Font
        | str
        | Iterable[fonts.Font | str] = (
            fonts.GoogleFont("IBM Plex Mono"),
            "ui-monospace",
            "monospace",
        ),
    ):
        super().__init__(
            primary_hue=primary_hue,
            secondary_hue=secondary_hue,
            neutral_hue=neutral_hue,
            spacing_size=spacing_size,
            radius_size=radius_size,
            text_size=text_size,
            font=font,
            font_mono=font_mono,
        )