
import hashlib,os,sys
from loguru import logger
logger.remove();logger.add(sys.stdout,colorize=True, format="<level>{message}</level>")

def calculate_file_hash(file_path):
    hash_object = hashlib.sha256()
    with open(file_path, 'rb') as file:
        for chunk in iter(lambda: file.read(4096), b""):
            hash_object.update(chunk)
    return hash_object.hexdigest()
def check_jsonl(file_name, num):
    file_hash = calculate_file_hash(file_name)
    if file_hash == num:
        return True
    logger.info("There are no .jsonl files, or the files are corrupted. We will download the files again.")
    return False
def calculate_folder_hash(file_path):
    if not os.path.isdir(file_path):
        logger.error(f"{file_path} is not a valid directory.")
        return 0
    total_hash = 0
    for root, _, files in os.walk(file_path):
        for file in files:
            if file.endswith('.jsonl'):
                full_file_path = os.path.join(root, file)
                file_hash = calculate_file_hash(full_file_path)
                total_hash += int(file_hash, 16)
    return hex(total_hash)
def check_folder(file_path,num):
    if not os.path.isdir(file_path):
        logger.error(f"{file_path} is not a valid directory.")
        return False
    return calculate_folder_hash(file_path)==num