


import importlib

BENCHMARK_MAP = {
    "vllm": ("models.server.vllm.vllm", "Vllm"),
    "sglang": ("models.server.SGLang.sglang", "SGLang"),
    "transformers": ("models.server.transformer.transformer", "Transformer"),
    "mamba": ("models.server.SSM.mamba", "Mamba"),
    "rwkv": ("models.server.RNN.rwkv", "Rwkv"),
    "SnapKV": ("models.acceleration.SnapKV.SnapKV", "SnapKV"),
    "KIVI": ("models.acceleration.KIVI.KIVI", "KIVI"),
    "H2O": ("models.acceleration.H2O.H2O", "H2O"),
    "StreamingLLM": ("models.acceleration.StreamingLLM.StreamingLLM", "StreamingLLM"),
    "L2Compress": ("models.acceleration.L2Compress.L2Compress", "L2Compress"),
    "CaM": ("models.acceleration.CaM.CaM", "CaM"),
    "CakeKV": ("models.acceleration.cake.cakekv", "cakekv"),
    "PyramidKV": ("models.acceleration.pyramidkv.pyramidkv", "pyramidkv"),
    "FlexPrefill": ("models.acceleration.flex_prefill.FlexPrifill", "FlexPrefill"),
    "ThinK": ("models.acceleration.think.think", "think"),
}
def RetrieveModel(model_type):
    module_path, class_name = BENCHMARK_MAP[model_type]
    # 导入模块
    module = importlib.import_module(module_path)
    return getattr(module,class_name)


        

