# Copyright 2024 ByteDance and/or its affiliates.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
from setuptools import find_packages, setup

setup(
    name="flex_prefill",
    version="0.1.0",
    packages=find_packages(),
    install_requires=["transformers==4.44.0", "triton==3.0.0", "einops"],
    author="XunhaoLai",
    author_email="laixunhao@pku.edu.cn",
    description="FlexPrefill sparse attention for efficient long sequence inference",
    long_description=open("README.md").read(),
    long_description_content_type="text/markdown",
    url="https://github.com/XunhaoLai/FlexPrefill",
    classifiers=[
        "Programming Language :: Python :: 3",
        "License :: OSI Approved :: MIT License",
        "Operating System :: OS Independent",
    ],
    python_requires=">=3.8.0",
)
