
import sys

from loguru import logger
from rank_bm25 import BM25Okapi

from models.rag.bass_class import Base

logger.remove();logger.add(sys.stdout,colorize=True, format="<level>{message}</level>")
class BM25(Base):
    def __init__(self,config):
        super().__init__(config)
        self.retrieval_methods = "BM25"
    def retrieve(self,context,question):
        chunks = self.retrieve_relevant_chunks_for_question(context, question)
        return chunks
    def retrieve_relevant_chunks_for_question(self,context, question):
        chunks = self.chunk_text(context)
        retriever = BM25Okapi(chunks)
        top_n = retriever.get_top_n(query = question, documents = chunks, n=self.num_chunks)
        return top_n
    
